﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace AddNewFieldWithDSBasedOnComboEditor
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm;
        public MainWindow()
        {
            InitializeComponent();
            combo.ItemsSource = GetComboData();
            vm = new ViewModel();
            xamDataGrid1.FieldSettings.AllowEdit = true;
            this.DataContext = vm;
         
        }

        public List<string> GetComboData() 
        {
            List<string> comboData = new List<string>();
            comboData.Add("Hobby");
            comboData.Add("Favorite Food");
            comboData.Add("Favorite Team");

           return comboData;
        }

        private void combo_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {            
            var selected = combo.SelectedItem;
            UnboundField newField = new UnboundField();
            bool exists = fieldExists(selected.ToString());

            newField.Name = selected.ToString();
            newField.DataType = typeof(string);

            if (selected != null && !exists)
            {                
                if (selected.ToString().Equals("Hobby")) 
                {
                    this.xamDataGrid1.FieldLayouts[0].Fields.Add(newField);

                    foreach (DataRecord dr in xamDataGrid1.Records)
                    {
                        dr.Cells["Hobby"].Value = vm.hobbiesData.Rows[dr.Index][1];
                    }
                }

                if (selected.ToString().Equals("Favorite Food"))
                {

                    this.xamDataGrid1.FieldLayouts[0].Fields.Add(newField);
                    newField.Width = new FieldLength(150);

                    foreach (DataRecord dr in xamDataGrid1.Records)
                    {
                        dr.Cells["Favorite Food"].Value = vm.foodData.Rows[dr.Index][1];
                    }
                }

                if (selected.ToString().Equals("Favorite Team"))
                {

                    this.xamDataGrid1.FieldLayouts[0].Fields.Add(newField);

                    foreach (DataRecord dr in xamDataGrid1.Records)
                    {
                        dr.Cells["Favorite Team"].Value = vm.teamsData.Rows[dr.Index][1];
                    }
                }
            }             
        }

        private bool fieldExists(string fieldName) 
        {
            bool exists = false;

            foreach (Field field in this.xamDataGrid1.FieldLayouts[0].Fields)
            {
                if (field.Name.Equals(fieldName))
                {
                    exists = true;
                    break;
                }
            }

            return exists;
        }
    }
}
