﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace AddNewFieldWithDSBasedOnComboEditor
{
    class ViewModel
    {
        public DataTable peopleData { get; set; }
        public DataTable hobbiesData { get; set; }
        public DataTable teamsData { get; set; }
        public DataTable foodData { get; set; }

        public ViewModel() 
        {
            this.peopleData = GetPeoapleData();
            this.hobbiesData = GetHobbiesData();
            this.teamsData = GetTeamsData();
            this.foodData = GetFoodData();            
        }

        private DataTable GetPeoapleData() 
        {
            DataTable data = new DataTable();
            string[] names = { "Peter", "Maria", "John", "Gustavo", "Vladimir" };

            data.Columns.Add("PersonID", typeof(UInt32));
            data.Columns.Add("Name", typeof(string));
            data.Columns.Add("Age", typeof(UInt16));

            for (int i = 0; i < 5; i++) 
            {
                var row = data.Rows.Add();
                row[0] = i + 1;
                row[1] = names[i];
                row[2] = 20 + i;
            }

            data.PrimaryKey = new DataColumn[] { data.Columns["PersonID"] };

            return data;
        }

        private DataTable GetHobbiesData()
        {
            DataTable data = new DataTable();
            string[] hobbies = { "Cooking", "Hiking","Fishing","Football","Gaming"}; 

            data.Columns.Add("HobbyID", typeof(UInt32));
            data.Columns.Add("Hobby", typeof(string));

            for (int i = 0; i < 5; i++) 
            {
                var row = data.Rows.Add();
                row[0] = i + 1;
                row[1] = hobbies[i];
            }

            return data;
        }

        private DataTable GetTeamsData()
        {
            DataTable data = new DataTable();
            string[] teams = { "Manchester United", "Manchester City", "Chelsea", "Liverpool", "Arsenal" };

            data.Columns.Add("TeamID", typeof(UInt32));
            data.Columns.Add("Favorite Team", typeof(string));

            for (int i = 0; i < 5; i++) 
            {
                var row = data.Rows.Add();
                row[0] = i + 1;
                row[1] = teams[i];
            }

            return data;
        }

        private DataTable GetFoodData()
        {
            DataTable data = new DataTable();
            string[] food = { "Spaghetti", "Sushi", "Chicken sweet and sour", "Lasagna", "Cheese burger" };

            data.Columns.Add("FoodID", typeof(UInt32));
            data.Columns.Add("Favorite Food", typeof(string));

            for (int i = 0; i < 5; i++)
            {
                var row = data.Rows.Add();
                row[0] = i + 1;
                row[1] = food[i];
            }

            return data;
        }
    }
}
